module CalcColors (x, y, snakex, snakey, seg1, seg2, seg3, seg4, clk, reset, GameOver, R, G, B) ;

input [9:0] x ;
input [9:0] y ;
input [9:0] snakex;
input [9:0] snakey;
input [11:0] seg1;
input [11:0] seg2;
input [11:0] seg3;
input [11:0] seg4;
input clk;
input reset;
input GameOver;
output R ;
output G ;
output B ;


reg snake1, snake2, snake3, snake4;         //tells us if we are within the snake or not
reg [9:0] x2, y2, x3, y3, x4, y4;
reg [11:0] seg2_2, seg3_2, seg4_2, seg3_3, seg4_3, seg4_4;
reg [9:0] snakey2, snakex2, snakey3, snakex3, snakey4, snakex4;

reg wall;


// add your declarations here

assign R = wall ? 1 : 0;
assign G = (snake4 || wall) ? 1 : 0;
assign B = wall ? 1 : 0;

always @(posedge clk) begin
	if (reset) begin
		snake1 <= 0;
		snake2 <= 0;
		snake3 <= 0;
		snake4 <= 0;
	end
	
	// Draw wall if coords are in wall
	if((x >= 0 && x < 10) || (x > 630 && x <= 640) || (y >= 0 && y < 10) || (y > 470 && y <= 480))
	  wall <= 1;
	else
	  wall <= 0;

	if(seg1[11:10] == 0) begin
	   if((y >= snakey) && (y <= (snakey + (seg1[9:0] * 2))) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   if (seg2[11:10] == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey + (seg1[9:0] * 2) - 10);
	end
	if(seg1[11:10] == 1) begin
	   if((y <= snakey) && (y >= (snakey - (seg1[9:0] * 2))) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   if (seg2[11:10] == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey - (seg1[9:0] * 2) + 10);	
	end
	if(seg1[11:10] == 2) begin
	   if((x >= snakex) && (x <= (snakex + (seg1[9:0] * 2))) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;  
	   snakex2 <= (snakex + (seg1[9:0] * 2) - 10);
	   if (seg2[11:10] == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	if(seg1[11:10] == 3) begin
	   if((x <= snakex) && (x >= (snakex - (seg1[9:0] * 2))) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   snakex2 <= (snakex - (seg1[9:0] * 2) + 10);
	   if (seg2[11:10] == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	
	//put values into registers for second stage of pipeline
	y2 <= y;
	x2 <= x;
	seg2_2 <= seg2;
	seg3_2 <= seg3;
	seg4_2 <= seg4;
	
	//check second segment coordinates and set snake accordingly   
	if(seg2_2[11:10] == 0) begin
	   if((y2 >= snakey2) && (y2 <= (snakey2 + (seg2_2[9:0] * 2))) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;
	   else 
	   	snake2 <= snake1;
	   if (seg3_2[11:10] == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 + (seg2_2[9:0] * 2) - 10);
	end
	else if(seg2_2[11:10] == 1) begin
	   if((y2 <= snakey2) && (y2 >= (snakey2 - (seg2_2[9:0] * 2))) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;	
	   else
	   	snake2 <= snake1;
	   if (seg3_2[11:10] == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 - (seg2_2[9:0] * 2) + 10);	
	end
	else if(seg2_2[11:10] == 2) begin
	   if((x2 >= snakex2) && (x2 <= (snakex2 + (seg2_2[9:0] * 2))) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	  else
	       snake2 <= snake1; 
	   snakex3 <= (snakex2 + (seg2_2[9:0] * 2) - 10);
	   if (seg3_2[11:10] == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	else if(seg2_2[11:10] == 3) begin
	   if((x2 <= snakex2) && (x2 >= (snakex2 - (seg2_2[9:0] * 2))) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	   else 
	   	snake2 <= snake1;
	   snakex3 <= (snakex2 - (seg2_2[9:0] * 2) + 10);
	   if (seg3_2[11:10] == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	
	//put values into registers for third stage of pipeline
	y3 <= y2;
	x3 <= x2;
	seg3_3 <= seg3_2;
	seg4_3 <= seg4_2;
	
	//check third segment coordinates and set snake accordingly   
	if(seg3_3[11:10] == 0) begin
	   if((y3 >= snakey3) && (y3 <= (snakey3 + (seg3_3[9:0] * 2))) && (x3 >= snakex3 - 10) && (x3 <= snakex3 + 10))
	   	snake3 <= 1;
	   else 
	   	snake3 <= snake2;
	   if (seg4_3[11:10] == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 + (seg3_3[9:0] * 2) - 10);
	end
	else if(seg3_3[11:10] == 1) begin
	   if((y3 <= snakey3) && (y3 >= (snakey3 - (seg3_3[9:0] * 2))) && (x3 >= snakex3 - 10) && (x3 <= snakex3 + 10))
	   	snake3 <= 1;	
	   else
	   	snake3 <= snake2;
	   if (seg4_3[11:10] == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 - (seg3_3[9:0] * 2) + 10);
	end
	else if(seg3_3[11:10] == 2) begin
	   if((x3 >= snakex3) && (x3 <= (snakex3 + (seg3_3[9:0] * 2))) && (y3 >= snakey3 - 10) && (y3 <= snakey3 + 10))
	   	snake3 <= 1;
	  else
	       snake3 <= snake2; 
	  snakex4 <= (snakex3 + (seg3_3[9:0] * 2) - 10);
	   if (seg4_3[11:10] == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	else if(seg3_3[11:10] == 3) begin
	   if((x3 <= snakex3) && (x3 >= (snakex3 - (seg3_3[9:0] * 2))) && (y3 >= snakey3 - 10) && (y3 <= snakey3 + 10))
	   	snake3 <= 1;
	   else 
	   	snake3 <= snake2;
	   snakex4 <= (snakex3 - (seg3_3[9:0] * 2) + 10);
	   if (seg4_3[11:10] == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	
	//put values into registers for fourth stage of pipeline
	y4 <= y3;
	x4 <= x3;
	seg4_4 <= seg4_3;
	
	//check fourth segment coordinates and set snake accordingly   
	if(seg4_4[11:10] == 0) begin
	   if((y4 >= snakey4) && (y4 <= (snakey4 + (seg4_4[9:0] * 2))) && (x4 >= snakex4 - 10) && (x4 <= snakex4 + 10))
	   	snake4 <= 1;
	   else 
	   	snake4 <= snake3;
	end
	else if(seg4_4[11:10] == 1) begin
	   if((y4 <= snakey4) && (y4 >= (snakey4 - (seg4_4[9:0] * 2))) && (x4 >= snakex4 - 10) && (x4 <= snakex4 + 10))
	   	snake4 <= 1;	
	   else
	   	snake4 <= snake3;
	end
	else if(seg4_4[11:10] == 2) begin
	   if((x4 >= snakex4) && (x4 <= (snakex4 + (seg4_4[9:0] * 2))) && (y4 >= snakey4 - 10) && (y4 <= snakey4 + 10))
	   	snake4 <= 1;
	  else
	       snake4 <= snake3; 
	end
	else if(seg4_4[11:10] == 3) begin
	   if((x4 <= snakex4) && (x4 >= (snakex4 - (seg4_4[9:0] * 2))) && (y4 >= snakey4 - 10) && (y4 <= snakey4 + 10))
	   	snake4 <= 1;
	   else 
	   	snake4 <= snake3;
	end	
	
end


endmodule 

