module IMGCTL (KEYBOARD, X, Y, CLK, CLR, WE, BG) ;

input [7:0] KEYBOARD ;
input [9:0] X ;
input [9:0] Y ;
input CLK ;
output [5:0] CLR ;
output WE ;
output BG ;

reg [7:0] tempKey;
reg [5:0] CLR;
reg WE, BG, didKeyAlready;

// add your declarations here

reg [9:0] X1, Y1, newX1, newY1;
reg [4:0] Xcnt, Ycnt;
reg [4:0] scale, newScale;
reg [8:0] scale16;

always @(posedge CLK) begin
  WE <= 0;
  
  if(X=='b1111111111 & Y=='b1111111111) begin
    CLR <= 0;
    scale <= newScale;
    scale16 <= newScale << 4;
    X1 <= newX1;
    Y1 <= newY1;
    Xcnt <= newScale;
    Ycnt <= newScale;
    BG <= 1;
  end
  
  if(X>=0 & Y>=0 & X<640 & Y<480) begin
  
    if((X >= X1 & X < (X1+scale16)) & (Y >= Y1 & Y < (Y1+scale16))) begin
      
      BG <= 0;
      if(Xcnt > 1) begin
      	Xcnt <= Xcnt - 1;
      end
      else if(Xcnt == 1) begin
      	CLR <= CLR + 1;
      	Xcnt <= scale;
      	if(X==(X1+scale16-1) & Ycnt > 1) begin
      	  CLR <= CLR - 15;
      	  Ycnt <= Ycnt - 1;
      	end
      	else if(X==(X1+scale16-1) & Ycnt == 1) begin
      	  Ycnt <= scale;
      	end
      end

    end
    else begin
      BG <= 1;
    end
  end

  if(!didKeyAlready) begin
    case(KEYBOARD)
      8'h2d: begin
             newScale <= 16;
             scale <= 16;
             newX1 <= 0;
             newY1 <= 0;
             X1 <= 0;
             Y1 <= 0;
      end
      8'h79: begin
             if((Y1+(newScale<<4)+(newScale<<1)) <= 479 & (X1+(newScale<<4)+(newScale<<1)) <= 639)
               newScale <= newScale + 1;
      end
      8'h7b: begin
             if(newScale > 1)
               newScale <= newScale - 1;
      end
      8'h75: begin
             if(newY1 > 0)
               newY1 <= newY1 - 1;
      end
      8'h72: begin
             if((newY1+scale16) < 479)
               newY1 <= newY1 + 1;
      end
      8'h6b: begin
             if((newX1) > 0)
               newX1 <= newX1 - 1;
      end
      8'h74: begin
             if((newX1+scale16) < 639)
               newX1 <= newX1 + 1;
      end
    endcase
    didKeyAlready <= 1;
    tempKey <= KEYBOARD;
  end
  if(tempKey != KEYBOARD)
    didKeyAlready <= 0;
end

// add your code here

endmodule 
