module mainctrl (clk, reset, VRGB, 
		 addBullet, addBulletx, addBullety, addBulletvx, addBulletvy, 
		 updateBullets, bulletproc, collide) ;

input clk ;
input reset ;
input bulletproc ;
input collide ;
input VRGB;

output addBullet ;
output [9:0] addBulletx ;
output [8:0] addBullety ;
output [2:0] addBulletvx ;
output [2:0] addBulletvy ;
output updateBullets ;

reg _addBullet;
assign addBullet = _addBullet;
reg _updateBullets;
assign updateBullets = _updateBullets;


reg VRGBPREV;
reg start;
reg startState;
//assert the start signal to the controller
always@(posedge clk) begin
	VRGBPREV <= VRGB;
	if(VRGB & !VRGBPREV)
		start <= 1;
	else
		start <= 0;
end

always@(posedge clk) begin

	if(reset) begin
		_addBullet <= 0;
		_updateBullets <= 0;
		startState <= 1;
	end
	else begin
		_addBullet <= 0;
		_updateBullets<= 0;
		if(startState & start) begin
			_addBullet <= 1;	
			startState <= 0;
		end
		else if(start) begin
			_updateBullets <= 1;	
		end
	end 
end

endmodule 
