------------------------------------------------------
-- LogiBLOX ROM Module "psprite"
-- Created by LogiBLOX version D.24
--    on Sat Mar 03 16:05:12 2001
-- Attributes 
--    MODTYPE = ROM
--    BUS_WIDTH = 3
--    DEPTH = 256
--    MEMFILE = playerrom
--    TRIM = FALSE
--    STYLE = MAX_SPEED
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY psprite IS
  PORT(
    A: IN std_logic_vector(7 DOWNTO 0);
    DO: OUT std_logic_vector(2 DOWNTO 0));
END psprite;

-- synopsys translate_off
ARCHITECTURE sim OF psprite IS
  SIGNAL START_PULSE: std_logic := '1';
  TYPE mem_data IS ARRAY (255 DOWNTO 0) OF std_logic_vector(2 DOWNTO 0);
BEGIN
  PROCESS
  VARIABLE VD: mem_data;
  VARIABLE first_time: BOOLEAN := TRUE;
  BEGIN
    IF (first_time) THEN
      VD(0) := ('0','0','0');
      VD(1) := ('1','1','1');
      VD(2) := ('1','1','1');
      VD(3) := ('1','1','1');
      VD(4) := ('1','1','1');
      VD(5) := ('1','1','1');
      VD(6) := ('1','1','1');
      VD(7) := ('0','0','0');
      VD(8) := ('1','1','1');
      VD(9) := ('0','0','0');
      VD(10) := ('0','1','1');
      VD(11) := ('0','1','1');
      VD(12) := ('1','0','0');
      VD(13) := ('1','0','0');
      VD(14) := ('0','0','0');
      VD(15) := ('1','1','1');
      VD(16) := ('1','1','1');
      VD(17) := ('0','1','1');
      VD(18) := ('0','0','0');
      VD(19) := ('0','1','1');
      VD(20) := ('1','0','0');
      VD(21) := ('0','0','0');
      VD(22) := ('1','0','0');
      VD(23) := ('1','1','1');
      VD(24) := ('1','1','1');
      VD(25) := ('0','1','1');
      VD(26) := ('0','1','1');
      VD(27) := ('0','0','0');
      VD(28) := ('0','0','0');
      VD(29) := ('1','0','0');
      VD(30) := ('1','0','0');
      VD(31) := ('1','1','1');
      VD(32) := ('1','1','1');
      VD(33) := ('1','0','1');
      VD(34) := ('1','0','1');
      VD(35) := ('0','0','0');
      VD(36) := ('0','0','0');
      VD(37) := ('1','1','0');
      VD(38) := ('1','1','0');
      VD(39) := ('1','1','1');
      VD(40) := ('1','1','1');
      VD(41) := ('1','0','1');
      VD(42) := ('0','0','0');
      VD(43) := ('1','0','1');
      VD(44) := ('1','1','0');
      VD(45) := ('0','0','0');
      VD(46) := ('1','1','0');
      VD(47) := ('1','1','1');
      VD(48) := ('1','1','1');
      VD(49) := ('0','0','0');
      VD(50) := ('1','0','1');
      VD(51) := ('1','0','1');
      VD(52) := ('1','1','0');
      VD(53) := ('1','1','0');
      VD(54) := ('0','0','0');
      VD(55) := ('1','1','1');
      VD(56) := ('0','0','0');
      VD(57) := ('1','1','1');
      VD(58) := ('1','1','1');
      VD(59) := ('1','1','1');
      VD(60) := ('1','1','1');
      VD(61) := ('1','1','1');
      VD(62) := ('1','1','1');
      VD(63) := ('0','0','0');
      VD(64) := ('0','0','0');
      VD(65) := ('1','1','1');
      VD(66) := ('1','1','1');
      VD(67) := ('1','1','1');
      VD(68) := ('1','1','1');
      VD(69) := ('1','1','1');
      VD(70) := ('1','1','1');
      VD(71) := ('0','0','0');
      VD(72) := ('1','1','1');
      VD(73) := ('0','0','0');
      VD(74) := ('0','1','1');
      VD(75) := ('0','1','1');
      VD(76) := ('1','0','0');
      VD(77) := ('1','0','0');
      VD(78) := ('0','0','0');
      VD(79) := ('1','1','1');
      VD(80) := ('1','1','1');
      VD(81) := ('0','1','1');
      VD(82) := ('0','0','0');
      VD(83) := ('0','1','1');
      VD(84) := ('1','0','0');
      VD(85) := ('0','0','0');
      VD(86) := ('1','0','0');
      VD(87) := ('1','1','1');
      VD(88) := ('1','1','1');
      VD(89) := ('0','1','1');
      VD(90) := ('0','1','1');
      VD(91) := ('0','0','0');
      VD(92) := ('0','0','0');
      VD(93) := ('1','0','0');
      VD(94) := ('1','0','0');
      VD(95) := ('1','1','1');
      VD(96) := ('1','1','1');
      VD(97) := ('1','0','1');
      VD(98) := ('1','0','1');
      VD(99) := ('0','0','0');
      VD(100) := ('0','0','0');
      VD(101) := ('1','1','0');
      VD(102) := ('1','1','0');
      VD(103) := ('1','1','1');
      VD(104) := ('1','1','1');
      VD(105) := ('1','0','1');
      VD(106) := ('0','0','0');
      VD(107) := ('1','0','1');
      VD(108) := ('1','1','0');
      VD(109) := ('0','0','0');
      VD(110) := ('1','1','0');
      VD(111) := ('1','1','1');
      VD(112) := ('1','1','1');
      VD(113) := ('0','0','0');
      VD(114) := ('1','0','1');
      VD(115) := ('1','0','1');
      VD(116) := ('1','1','0');
      VD(117) := ('1','1','0');
      VD(118) := ('0','0','0');
      VD(119) := ('1','1','1');
      VD(120) := ('0','0','0');
      VD(121) := ('1','1','1');
      VD(122) := ('1','1','1');
      VD(123) := ('1','1','1');
      VD(124) := ('1','1','1');
      VD(125) := ('1','1','1');
      VD(126) := ('1','1','1');
      VD(127) := ('0','0','0');
      VD(128) := ('0','0','0');
      VD(129) := ('1','1','1');
      VD(130) := ('1','1','1');
      VD(131) := ('1','1','1');
      VD(132) := ('1','1','1');
      VD(133) := ('1','1','1');
      VD(134) := ('1','1','1');
      VD(135) := ('0','0','0');
      VD(136) := ('1','1','1');
      VD(137) := ('0','0','0');
      VD(138) := ('0','1','1');
      VD(139) := ('0','1','1');
      VD(140) := ('1','0','0');
      VD(141) := ('1','0','0');
      VD(142) := ('0','0','0');
      VD(143) := ('1','1','1');
      VD(144) := ('1','1','1');
      VD(145) := ('0','1','1');
      VD(146) := ('0','0','0');
      VD(147) := ('0','1','1');
      VD(148) := ('1','0','0');
      VD(149) := ('0','0','0');
      VD(150) := ('1','0','0');
      VD(151) := ('1','1','1');
      VD(152) := ('1','1','1');
      VD(153) := ('0','1','1');
      VD(154) := ('0','1','1');
      VD(155) := ('0','0','0');
      VD(156) := ('0','0','0');
      VD(157) := ('1','0','0');
      VD(158) := ('1','0','0');
      VD(159) := ('1','1','1');
      VD(160) := ('1','1','1');
      VD(161) := ('1','0','1');
      VD(162) := ('1','0','1');
      VD(163) := ('0','0','0');
      VD(164) := ('0','0','0');
      VD(165) := ('1','1','0');
      VD(166) := ('1','1','0');
      VD(167) := ('1','1','1');
      VD(168) := ('1','1','1');
      VD(169) := ('1','0','1');
      VD(170) := ('0','0','0');
      VD(171) := ('1','0','1');
      VD(172) := ('1','1','0');
      VD(173) := ('0','0','0');
      VD(174) := ('1','1','0');
      VD(175) := ('1','1','1');
      VD(176) := ('1','1','1');
      VD(177) := ('0','0','0');
      VD(178) := ('1','0','1');
      VD(179) := ('1','0','1');
      VD(180) := ('1','1','0');
      VD(181) := ('1','1','0');
      VD(182) := ('0','0','0');
      VD(183) := ('1','1','1');
      VD(184) := ('0','0','0');
      VD(185) := ('1','1','1');
      VD(186) := ('1','1','1');
      VD(187) := ('1','1','1');
      VD(188) := ('1','1','1');
      VD(189) := ('1','1','1');
      VD(190) := ('1','1','1');
      VD(191) := ('0','0','0');
      VD(192) := ('0','0','0');
      VD(193) := ('1','1','1');
      VD(194) := ('1','1','1');
      VD(195) := ('1','1','1');
      VD(196) := ('1','1','1');
      VD(197) := ('1','1','1');
      VD(198) := ('1','1','1');
      VD(199) := ('0','0','0');
      VD(200) := ('1','1','1');
      VD(201) := ('0','0','0');
      VD(202) := ('0','1','1');
      VD(203) := ('0','1','1');
      VD(204) := ('1','0','0');
      VD(205) := ('1','0','0');
      VD(206) := ('0','0','0');
      VD(207) := ('1','1','1');
      VD(208) := ('1','1','1');
      VD(209) := ('0','1','1');
      VD(210) := ('0','0','0');
      VD(211) := ('0','1','1');
      VD(212) := ('1','0','0');
      VD(213) := ('0','0','0');
      VD(214) := ('1','0','0');
      VD(215) := ('1','1','1');
      VD(216) := ('1','1','1');
      VD(217) := ('0','1','1');
      VD(218) := ('0','1','1');
      VD(219) := ('0','0','0');
      VD(220) := ('0','0','0');
      VD(221) := ('1','0','0');
      VD(222) := ('1','0','0');
      VD(223) := ('1','1','1');
      VD(224) := ('1','1','1');
      VD(225) := ('1','0','1');
      VD(226) := ('1','0','1');
      VD(227) := ('0','0','0');
      VD(228) := ('0','0','0');
      VD(229) := ('1','1','0');
      VD(230) := ('1','1','0');
      VD(231) := ('1','1','1');
      VD(232) := ('1','1','1');
      VD(233) := ('1','0','1');
      VD(234) := ('0','0','0');
      VD(235) := ('1','0','1');
      VD(236) := ('1','1','0');
      VD(237) := ('0','0','0');
      VD(238) := ('1','1','0');
      VD(239) := ('1','1','1');
      VD(240) := ('1','1','1');
      VD(241) := ('0','0','0');
      VD(242) := ('1','0','1');
      VD(243) := ('1','0','1');
      VD(244) := ('1','1','0');
      VD(245) := ('1','1','0');
      VD(246) := ('0','0','0');
      VD(247) := ('1','1','1');
      VD(248) := ('0','0','0');
      VD(249) := ('1','1','1');
      VD(250) := ('1','1','1');
      VD(251) := ('1','1','1');
      VD(252) := ('1','1','1');
      VD(253) := ('1','1','1');
      VD(254) := ('1','1','1');
      VD(255) := ('0','0','0');
      first_time := FALSE;
    END IF;
    IF (mvlvec_not01(A)) THEN
      DO <= ('X','X','X');
    ELSIF (mvlvec2int(A) > 255) THEN
      ASSERT (FALSE)
      REPORT "The value on the address line is out of range"
      SEVERITY WARNING;
      DO <= ('X','X','X');
    ELSE
      DO <= VD(mvlvec2int(A));
    END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
